<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: ehrhart.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>ehrhart.h File Reference</h1>
<p><a href="ehrhart_8h_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#adfc5a48cdab1ce4848c8f03a2707dcf9">count_points</a> (int pos, <a class="el" href="structpolyhedron.html">Polyhedron</a> *P, Value *context, Value *res)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">PROCEDURES TO COMPUTE ENUMERATION.  <a href="#adfc5a48cdab1ce4848c8f03a2707dcf9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#a62b0031a3ec0fb5e8c88bcf291c006a0">eadd</a> (<a class="el" href="struct__evalue.html">evalue</a> *e1, <a class="el" href="struct__evalue.html">evalue</a> *res)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">adds one evalue to evalue 'res.  <a href="#a62b0031a3ec0fb5e8c88bcf291c006a0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__enode.html">enode</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#ac94c9f3a408511c6ea5defdc47eb6563">ecopy</a> (<a class="el" href="struct__enode.html">enode</a> *e)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#a197ef6aec479254f610d450de8890d02">edot</a> (<a class="el" href="struct__enode.html">enode</a> *v1, <a class="el" href="struct__enode.html">enode</a> *v2, <a class="el" href="struct__evalue.html">evalue</a> *res)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">computes the inner product of two vectors.  <a href="#a197ef6aec479254f610d450de8890d02"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__enode.html">enode</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#a7acd3dfb7d74bf5551bce6f31f7189bc">new_enode</a> (<a class="el" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409fed">enode_type</a> type, int <a class="el" href="vector_8c.html#a439227feff9d7f55384e8780cfc2eb82">size</a>, int pos)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">EHRHART POLYNOMIAL SYMBOLIC ALGEBRA SYSTEM.  <a href="#a7acd3dfb7d74bf5551bce6f31f7189bc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#a96434ed8279f7999773fa3343cfe98b8">free_evalue_refs</a> (<a class="el" href="struct__evalue.html">evalue</a> *e)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">releases all memory referenced by e.  <a href="#a96434ed8279f7999773fa3343cfe98b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__enumeration.html">Enumeration</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#a4ec60633863169ad9342edbe0884b364">Polyhedron_Enumerate</a> (<a class="el" href="structpolyhedron.html">Polyhedron</a> *P, <a class="el" href="structpolyhedron.html">Polyhedron</a> *C, unsigned MAXRAYS, const char **pname)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Procedure to count points in a parameterized polytope.  <a href="#a4ec60633863169ad9342edbe0884b364"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#a84dff5d1187317811e98a92ac8a37fa3">print_enode</a> (FILE *DST, <a class="el" href="struct__enode.html">enode</a> *<a class="el" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, const char **pname)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">prints the enode to DST  <a href="#a84dff5d1187317811e98a92ac8a37fa3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#a99718adf05e065181f35f5ca847f94b0">print_evalue</a> (FILE *DST, <a class="el" href="struct__evalue.html">evalue</a> *e, const char **pname)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#ae02ef07ca7d9de519ffe46a89e941bb8">reduce_evalue</a> (<a class="el" href="struct__evalue.html">evalue</a> *e)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#aeaadcf4c2404d688eb1443486ad8becb">Enumeration_Free</a> (<a class="el" href="struct__enumeration.html">Enumeration</a> *en)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__enumeration.html">Enumeration</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#a115270362b32051ceb2acd7160d191d1">Ehrhart_Quick_Apx</a> (<a class="el" href="structmatrix.html">Matrix</a> *M, <a class="el" href="structmatrix.html">Matrix</a> *C, <a class="el" href="structmatrix.html">Matrix</a> **Validity_Lattice, unsigned MAXRAYS)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Computes the approximation of the <a class="el" href="classEhrhart.html">Ehrhart</a> polynomial of a <a class="el" href="structpolyhedron.html">polyhedron</a> (implicit form -&gt; <a class="el" href="structmatrix.html">matrix</a>), treating the non-full-dimensional case.  <a href="#a115270362b32051ceb2acd7160d191d1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__enumeration.html">Enumeration</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="ehrhart_8h.html#ab9d946f486657c1fde2ff63537f004fb">Enumeration_zero</a> (unsigned int nbParms, unsigned int maxRays)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">returns a constant <a class="el" href="classEhrhart.html">Ehrhart</a> polynomial whose value is zero for any value of the parameters.  <a href="#ab9d946f486657c1fde2ff63537f004fb"></a><br/></td></tr>
</table>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="adfc5a48cdab1ce4848c8f03a2707dcf9"></a><!-- doxytag: member="ehrhart.h::count_points" ref="adfc5a48cdab1ce4848c8f03a2707dcf9" args="(int pos, Polyhedron *P, Value *context, Value *res)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void count_points </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structpolyhedron.html">Polyhedron</a> *&nbsp;</td>
          <td class="paramname"> <em>P</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>context</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">Value *&nbsp;</td>
          <td class="paramname"> <em>res</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>PROCEDURES TO COMPUTE ENUMERATION. </p>
<p>recursive procedure, recurse for each imbriquation</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>pos</em>&nbsp;</td><td>index position of current loop index (1..hdim-1) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>P</em>&nbsp;</td><td>loop domain </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>context</em>&nbsp;</td><td>context values for fixed indices </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>res</em>&nbsp;</td><td>the number of integer points in this <a class="el" href="structpolyhedron.html">polyhedron</a> </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l01145">1145</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="ehrhart_8c_source.html#l01145">count_points()</a>, <a class="el" href="types_8h_source.html#l00134">emptyQ</a>, <a class="el" href="polyhedron_8c_source.html#l03805">lower_upper_bounds()</a>, <a class="el" href="types_8h_source.html#l00115">polyhedron::next</a>, <a class="el" href="types_8h_source.html#l00061">P_VALUE_FMT</a>, <a class="el" href="polyhedron_8h_source.html#l00030">POL_ENSURE_FACETS</a>, <a class="el" href="polyhedron_8h_source.html#l00034">POL_ENSURE_VERTICES</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00515">value_add_int</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00514">value_addto</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00517">value_increment</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00482">value_le</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00481">value_lt</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00558">value_notmone_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00464">value_print</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00520">value_subtract</a>.</p>

<p>Referenced by <a class="el" href="verif__ehrhart_8c_source.html#l00078">check_poly()</a>, <a class="el" href="ehrhart_8c_source.html#l01145">count_points()</a>, <a class="el" href="ehrhart_8c_source.html#l01738">Enumerate_NoParameters()</a>, and <a class="el" href="ehrhart_8c_source.html#l01246">P_Enum()</a>.</p>

</div>
</div>
<a class="anchor" id="a62b0031a3ec0fb5e8c88bcf291c006a0"></a><!-- doxytag: member="ehrhart.h::eadd" ref="a62b0031a3ec0fb5e8c88bcf291c006a0" args="(evalue *e1, evalue *res)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void eadd </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__evalue.html">evalue</a> *&nbsp;</td>
          <td class="paramname"> <em>e1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct__evalue.html">evalue</a> *&nbsp;</td>
          <td class="paramname"> <em>res</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>adds one evalue to evalue 'res. </p>
<p>result = res + e1</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>e1</em>&nbsp;</td><td>an evalue </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>res</em>&nbsp;</td><td></td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l00410">410</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00201">_enode::arr</a>, <a class="el" href="types_8h_source.html#l00190">_evalue::d</a>, <a class="el" href="ehrhart_8c_source.html#l00410">eadd()</a>, <a class="el" href="ehrhart_8c_source.html#l00167">ecopy()</a>, <a class="el" href="ehrhart_8c_source.html#l00139">free_evalue_refs()</a>, <a class="el" href="types_8h_source.html#l00181">periodic</a>, <a class="el" href="types_8h_source.html#l00181">polynomial</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00514">value_addto</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00524">value_divexact</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00532">value_gcd</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00519">value_multiply</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00556">value_notone_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00553">value_zero_p</a>.</p>

<p>Referenced by <a class="el" href="ehrhart_8c_source.html#l00410">eadd()</a>, and <a class="el" href="ehrhart_8c_source.html#l00526">edot()</a>.</p>

</div>
</div>
<a class="anchor" id="ac94c9f3a408511c6ea5defdc47eb6563"></a><!-- doxytag: member="ehrhart.h::ecopy" ref="ac94c9f3a408511c6ea5defdc47eb6563" args="(enode *e)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="struct__enode.html">enode</a>* ecopy </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__enode.html">enode</a> *&nbsp;</td>
          <td class="paramname"> <em>e</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>e</em>&nbsp;</td><td>pointer to an evalue </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>description </dd></dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l00167">167</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00201">_enode::arr</a>, <a class="el" href="types_8h_source.html#l00190">_evalue::d</a>, <a class="el" href="ehrhart_8c_source.html#l00167">ecopy()</a>, <a class="el" href="ehrhart_8c_source.html#l00114">new_enode()</a>, <a class="el" href="types_8h_source.html#l00200">_enode::pos</a>, <a class="el" href="types_8h_source.html#l00199">_enode::size</a>, <a class="el" href="types_8h_source.html#l00198">_enode::type</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00459">value_assign</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00553">value_zero_p</a>.</p>

<p>Referenced by <a class="el" href="ext__ehrhart_8c_source.html#l00702">Domain_Enumerate()</a>, <a class="el" href="ehrhart_8c_source.html#l00410">eadd()</a>, <a class="el" href="ehrhart_8c_source.html#l00167">ecopy()</a>, and <a class="el" href="ext__ehrhart_8c_source.html#l00320">new_eadd()</a>.</p>

</div>
</div>
<a class="anchor" id="a197ef6aec479254f610d450de8890d02"></a><!-- doxytag: member="ehrhart.h::edot" ref="a197ef6aec479254f610d450de8890d02" args="(enode *v1, enode *v2, evalue *res)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void edot </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__enode.html">enode</a> *&nbsp;</td>
          <td class="paramname"> <em>v1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct__enode.html">enode</a> *&nbsp;</td>
          <td class="paramname"> <em>v2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct__evalue.html">evalue</a> *&nbsp;</td>
          <td class="paramname"> <em>res</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>computes the inner product of two vectors. </p>
<p>Result = result (evalue) = v1.v2 (dot product)</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>v1</em>&nbsp;</td><td>an enode (vector) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>v2</em>&nbsp;</td><td>an enode (vector of constants) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>res</em>&nbsp;</td><td>result (evalue) </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l00526">526</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00201">_enode::arr</a>, <a class="el" href="types_8h_source.html#l00190">_evalue::d</a>, <a class="el" href="ehrhart_8c_source.html#l00410">eadd()</a>, <a class="el" href="ehrhart_8c_source.html#l00368">emul()</a>, <a class="el" href="types_8h_source.html#l00181">evector</a>, <a class="el" href="ehrhart_8c_source.html#l00139">free_evalue_refs()</a>, <a class="el" href="types_8h_source.html#l00199">_enode::size</a>, <a class="el" href="types_8h_source.html#l00198">_enode::type</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="ehrhart_8c_source.html#l01246">P_Enum()</a>.</p>

</div>
</div>
<a class="anchor" id="a115270362b32051ceb2acd7160d191d1"></a><!-- doxytag: member="ehrhart.h::Ehrhart_Quick_Apx" ref="a115270362b32051ceb2acd7160d191d1" args="(Matrix *M, Matrix *C, Matrix **Validity_Lattice, unsigned MAXRAYS)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="struct__enumeration.html">Enumeration</a>* Ehrhart_Quick_Apx </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>M</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> *&nbsp;</td>
          <td class="paramname"> <em>C</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structmatrix.html">Matrix</a> **&nbsp;</td>
          <td class="paramname"> <em>Validity_Lattice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned&nbsp;</td>
          <td class="paramname"> <em>maxRays</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Computes the approximation of the <a class="el" href="classEhrhart.html">Ehrhart</a> polynomial of a <a class="el" href="structpolyhedron.html">polyhedron</a> (implicit form -&gt; <a class="el" href="structmatrix.html">matrix</a>), treating the non-full-dimensional case. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>M</em>&nbsp;</td><td>a <a class="el" href="structpolyhedron.html">polyhedron</a> under implicit form </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>C</em>&nbsp;</td><td>M's context under implicit form </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>Validity_Lattice</em>&nbsp;</td><td>a pointer to the parameter's validity lattice </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>MAXRAYS</em>&nbsp;</td><td>the needed "working space" for other polylib functions used here </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>param_name</em>&nbsp;</td><td>the names of the parameters, </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l02635">2635</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="polyhedron_8c_source.html#l01906">Constraints2Polyhedron()</a>, <a class="el" href="ehrhart_8c_source.html#l02281">Ehrhart_Quick_Apx_Full_Dim()</a>, <a class="el" href="compress__parms_8c_source.html#l00904">full_dimensionize()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="matrix__addon_8c_source.html#l00293">mpolyhedron_compress_last_vars()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="polyhedron_8c_source.html#l01603">Polyhedron_Free()</a>, and <a class="el" href="matrix__addon_8h_source.html#l00032">show_matrix</a>.</p>

<p>Referenced by <a class="el" href="ehrhart_8c_source.html#l02677">Constraints_EhrhartQuickApx()</a>, and <a class="el" href="ehrhart__lower__bound_8c_source.html#l00025">main()</a>.</p>

</div>
</div>
<a class="anchor" id="aeaadcf4c2404d688eb1443486ad8becb"></a><!-- doxytag: member="ehrhart.h::Enumeration_Free" ref="aeaadcf4c2404d688eb1443486ad8becb" args="(Enumeration *en)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Enumeration_Free </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__enumeration.html">Enumeration</a> *&nbsp;</td>
          <td class="paramname"> <em>en</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l02220">2220</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="polyhedron_8c_source.html#l01616">Domain_Free()</a>, <a class="el" href="types_8h_source.html#l00207">_enumeration::EP</a>, <a class="el" href="ehrhart_8c_source.html#l00139">free_evalue_refs()</a>, <a class="el" href="types_8h_source.html#l00208">_enumeration::next</a>, and <a class="el" href="types_8h_source.html#l00206">_enumeration::ValidityDomain</a>.</p>

<p>Referenced by <a class="el" href="testehrhart_8c_source.html#l00130">main()</a>, and <a class="el" href="testCompressParms_8c_source.html#l00273">test_Constraints_fullDimensionize()</a>.</p>

</div>
</div>
<a class="anchor" id="ab9d946f486657c1fde2ff63537f004fb"></a><!-- doxytag: member="ehrhart.h::Enumeration_zero" ref="ab9d946f486657c1fde2ff63537f004fb" args="(unsigned int nbParms, unsigned int maxRays)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="struct__enumeration.html">Enumeration</a>* Enumeration_zero </td>
          <td>(</td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>nbParms</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&nbsp;</td>
          <td class="paramname"> <em>maxRays</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>returns a constant <a class="el" href="classEhrhart.html">Ehrhart</a> polynomial whose value is zero for any value of the parameters. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>nbParms</em>&nbsp;</td><td>the number of parameters, i.e., the number of arguments to the <a class="el" href="classEhrhart.html">Ehrhart</a> polynomial </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l02732">2732</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="polyhedron_8c_source.html#l01906">Constraints2Polyhedron()</a>, <a class="el" href="matrix_8c_source.html#l00045">Matrix_Alloc()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="types_8h_source.html#l00093">matrix::p</a>, <a class="el" href="ehrhart_8c_source.html#l01860">Polyhedron_Enumerate()</a>, <a class="el" href="polyhedron_8c_source.html#l01603">Polyhedron_Free()</a>, <a class="el" href="polyhedron_8c_source.html#l01748">Universe_Polyhedron()</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="testCompressParms_8c_source.html#l00273">test_Constraints_fullDimensionize()</a>.</p>

</div>
</div>
<a class="anchor" id="a96434ed8279f7999773fa3343cfe98b8"></a><!-- doxytag: member="ehrhart.h::free_evalue_refs" ref="a96434ed8279f7999773fa3343cfe98b8" args="(evalue *e)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void free_evalue_refs </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__evalue.html">evalue</a> *&nbsp;</td>
          <td class="paramname"> <em>e</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>releases all memory referenced by e. </p>
<p>(recursive) </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>e</em>&nbsp;</td><td>pointer to an evalue </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l00139">139</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00201">_enode::arr</a>, <a class="el" href="types_8h_source.html#l00190">_evalue::d</a>, <a class="el" href="ehrhart_8c_source.html#l00139">free_evalue_refs()</a>, <a class="el" href="vector_8c_source.html#l00760">p</a>, <a class="el" href="types_8h_source.html#l00199">_enode::size</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>.</p>

<p>Referenced by <a class="el" href="homogenization_8c_source.html#l00048">dehomogenize_evalue()</a>, <a class="el" href="ext__ehrhart_8c_source.html#l00702">Domain_Enumerate()</a>, <a class="el" href="ehrhart_8c_source.html#l00410">eadd()</a>, <a class="el" href="ehrhart_8c_source.html#l00526">edot()</a>, <a class="el" href="ehrhart_8c_source.html#l02220">Enumeration_Free()</a>, <a class="el" href="ehrhart_8c_source.html#l00139">free_evalue_refs()</a>, <a class="el" href="ehrhart__lower__bound_8c_source.html#l00025">main()</a>, <a class="el" href="ehrhart_8c_source.html#l01246">P_Enum()</a>, and <a class="el" href="ehrhart_8c_source.html#l00295">reduce_evalue()</a>.</p>

</div>
</div>
<a class="anchor" id="a7acd3dfb7d74bf5551bce6f31f7189bc"></a><!-- doxytag: member="ehrhart.h::new_enode" ref="a7acd3dfb7d74bf5551bce6f31f7189bc" args="(enode_type type, int size, int pos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="struct__enode.html">enode</a>* new_enode </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409fed">enode_type</a>&nbsp;</td>
          <td class="paramname"> <em>type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>pos</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>EHRHART POLYNOMIAL SYMBOLIC ALGEBRA SYSTEM. </p>
<p>The newly allocated enode can be freed with a simple free(x)</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>type</em>&nbsp;</td><td>: enode type </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>size</em>&nbsp;</td><td>: degree+1 for polynomial, period for periodic </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pos</em>&nbsp;</td><td>: 1..nb_param, position of parameter </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>a newly allocated enode </dd></dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l00114">114</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00201">_enode::arr</a>, <a class="el" href="types_8h_source.html#l00190">_evalue::d</a>, <a class="el" href="types_8h_source.html#l00200">_enode::pos</a>, <a class="el" href="types_8h_source.html#l00199">_enode::size</a>, <a class="el" href="types_8h_source.html#l00198">_enode::type</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>.</p>

<p>Referenced by <a class="el" href="ehrhart_8c_source.html#l00167">ecopy()</a>, <a class="el" href="ehrhart_8c_source.html#l00368">emul()</a>, <a class="el" href="ehrhart_8c_source.html#l01738">Enumerate_NoParameters()</a>, <a class="el" href="ext__ehrhart_8c_source.html#l00320">new_eadd()</a>, and <a class="el" href="ehrhart_8c_source.html#l01246">P_Enum()</a>.</p>

</div>
</div>
<a class="anchor" id="a4ec60633863169ad9342edbe0884b364"></a><!-- doxytag: member="ehrhart.h::Polyhedron_Enumerate" ref="a4ec60633863169ad9342edbe0884b364" args="(Polyhedron *P, Polyhedron *C, unsigned MAXRAYS, const char **pname)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="struct__enumeration.html">Enumeration</a>* Polyhedron_Enumerate </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structpolyhedron.html">Polyhedron</a> *&nbsp;</td>
          <td class="paramname"> <em>Pi</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structpolyhedron.html">Polyhedron</a> *&nbsp;</td>
          <td class="paramname"> <em>C</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned&nbsp;</td>
          <td class="paramname"> <em>MAXRAYS</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char **&nbsp;</td>
          <td class="paramname"> <em>param_name</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Procedure to count points in a parameterized polytope. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>Pi</em>&nbsp;</td><td>Polyhedron to enumerate </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>C</em>&nbsp;</td><td>Context Domain </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>MAXRAYS</em>&nbsp;</td><td>size of workspace </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>param_name</em>&nbsp;</td><td>parameter names (array of strings), may be NULL </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>a list of validity domains + evalues EP </dd></dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l01860">1860</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="ehrhart_8c_source.html#l00589">addeliminatedparams_evalue()</a>, <a class="el" href="assert_8h_source.html#l00026">assert</a>, <a class="el" href="source_2arith_2arithmetic__errors_8h_source.html#l00122">CATCH</a>, <a class="el" href="types_8h_source.html#l00160">_Param_Polyhedron::D</a>, <a class="el" href="types_8h_source.html#l00190">_evalue::d</a>, <a class="el" href="homogenization_8c_source.html#l00048">dehomogenize_evalue()</a>, <a class="el" href="types_8h_source.html#l00110">polyhedron::Dimension</a>, <a class="el" href="types_8h_source.html#l00153">_Param_Domain::Domain</a>, <a class="el" href="polyhedron_8c_source.html#l01616">Domain_Free()</a>, <a class="el" href="polyhedron_8c_source.html#l02607">DomainIntersection()</a>, <a class="el" href="polyhedron_8c_source.html#l03260">DomainSimplify()</a>, <a class="el" href="types_8h_source.html#l00134">emptyQ</a>, <a class="el" href="ehrhart_8c_source.html#l01738">Enumerate_NoParameters()</a>, <a class="el" href="types_8h_source.html#l00207">_enumeration::EP</a>, <a class="el" href="types_8h_source.html#l00152">_Param_Domain::F</a>, <a class="el" href="homogenization_8c_source.html#l00031">homogenize()</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="types_8h_source.html#l00110">polyhedron::NbBid</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00110">polyhedron::NbEq</a>, <a class="el" href="types_8h_source.html#l00110">polyhedron::NbRays</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbRows</a>, <a class="el" href="types_8h_source.html#l00154">_Param_Domain::next</a>, <a class="el" href="types_8h_source.html#l00208">_enumeration::next</a>, <a class="el" href="errors_8c_source.html#l00109">overflow_error</a>, <a class="el" href="ehrhart_8c_source.html#l00098">overflow_warning_flag</a>, <a class="el" href="ehrhart_8c_source.html#l01246">P_Enum()</a>, <a class="el" href="types_8h_source.html#l00061">P_VALUE_FMT</a>, <a class="el" href="polyparam_8c_source.html#l01880">Param_Polyhedron_Free()</a>, <a class="el" href="polyparam_8c_source.html#l01577">Param_Vertices_Free()</a>, <a class="el" href="polyhedron_8h_source.html#l00030">POL_ENSURE_FACETS</a>, <a class="el" href="polyhedron_8h_source.html#l00034">POL_ENSURE_VERTICES</a>, <a class="el" href="types_8h_source.html#l00084">POL_ISSET</a>, <a class="el" href="types_8h_source.html#l00082">POL_NO_DUAL</a>, <a class="el" href="polyparam_8c_source.html#l01816">Polyhedron2Param_SimplifiedDomain()</a>, <a class="el" href="polyhedron_8c_source.html#l01603">Polyhedron_Free()</a>, <a class="el" href="polyhedron_8c_source.html#l04002">Polyhedron_Preimage()</a>, <a class="el" href="ehrhart_8c_source.html#l00744">Polyhedron_Preprocess()</a>, <a class="el" href="ehrhart_8c_source.html#l00899">Polyhedron_Preprocess2()</a>, <a class="el" href="polyhedron_8c_source.html#l01630">Polyhedron_Print()</a>, <a class="el" href="polyhedron_8c_source.html#l03743">Polyhedron_Scan()</a>, <a class="el" href="polyhedron_8c_source.html#l02388">PolyhedronIncludes()</a>, <a class="el" href="polyparam_8c_source.html#l01693">Print_Domain()</a>, <a class="el" href="ehrhart_8c_source.html#l00192">print_evalue()</a>, <a class="el" href="types_8h_source.html#l00112">polyhedron::Ray</a>, <a class="el" href="ehrhart_8c_source.html#l00295">reduce_evalue()</a>, <a class="el" href="ehrhart_8c_source.html#l01660">Scan_Vertices()</a>, <a class="el" href="source_2arith_2arithmetic__errors_8h_source.html#l00130">TRY</a>, <a class="el" href="source_2arith_2arithmetic__errors_8h_source.html#l00126">UNCATCH</a>, <a class="el" href="polyhedron_8c_source.html#l01748">Universe_Polyhedron()</a>, <a class="el" href="types_8h_source.html#l00159">_Param_Polyhedron::V</a>, <a class="el" href="types_8h_source.html#l00206">_enumeration::ValidityDomain</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00514">value_addto</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00519">value_multiply</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00464">value_print</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00460">value_set_si</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00553">value_zero_p</a>, and <a class="el" href="vector_8c_source.html#l00240">Vector_Set()</a>.</p>

<p>Referenced by <a class="el" href="ext__ehrhart_8c_source.html#l00702">Domain_Enumerate()</a>, <a class="el" href="ehrhart_8c_source.html#l02732">Enumeration_zero()</a>, <a class="el" href="testehrhart_8c_source.html#l00130">main()</a>, and <a class="el" href="testCompressParms_8c_source.html#l00273">test_Constraints_fullDimensionize()</a>.</p>

</div>
</div>
<a class="anchor" id="a84dff5d1187317811e98a92ac8a37fa3"></a><!-- doxytag: member="ehrhart.h::print_enode" ref="a84dff5d1187317811e98a92ac8a37fa3" args="(FILE *DST, enode *p, const char **pname)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void print_enode </td>
          <td>(</td>
          <td class="paramtype">FILE *&nbsp;</td>
          <td class="paramname"> <em>DST</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct__enode.html">enode</a> *&nbsp;</td>
          <td class="paramname"> <em>p</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char **&nbsp;</td>
          <td class="paramname"> <em>pname</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>prints the enode to DST </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>DST</em>&nbsp;</td><td>destination file </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>p</em>&nbsp;</td><td>pointer to enode to be printed </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pname</em>&nbsp;</td><td>array of strings, name of the parameters </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l00216">216</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00201">_enode::arr</a>, <a class="el" href="types_8h_source.html#l00181">evector</a>, <a class="el" href="types_8h_source.html#l00181">periodic</a>, <a class="el" href="types_8h_source.html#l00181">polynomial</a>, <a class="el" href="types_8h_source.html#l00200">_enode::pos</a>, <a class="el" href="ehrhart_8c_source.html#l00192">print_evalue()</a>, <a class="el" href="types_8h_source.html#l00199">_enode::size</a>, and <a class="el" href="types_8h_source.html#l00198">_enode::type</a>.</p>

<p>Referenced by <a class="el" href="ehrhart_8c_source.html#l01246">P_Enum()</a>, and <a class="el" href="ehrhart_8c_source.html#l00192">print_evalue()</a>.</p>

</div>
</div>
<a class="anchor" id="a99718adf05e065181f35f5ca847f94b0"></a><!-- doxytag: member="ehrhart.h::print_evalue" ref="a99718adf05e065181f35f5ca847f94b0" args="(FILE *DST, evalue *e, const char **pname)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void print_evalue </td>
          <td>(</td>
          <td class="paramtype">FILE *&nbsp;</td>
          <td class="paramname"> <em>DST</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct__evalue.html">evalue</a> *&nbsp;</td>
          <td class="paramname"> <em>e</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char **&nbsp;</td>
          <td class="paramname"> <em>pname</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>DST</em>&nbsp;</td><td>destination file </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>e</em>&nbsp;</td><td>pointer to evalue to be printed </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pname</em>&nbsp;</td><td>array of strings, name of the parameters </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l00192">192</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00190">_evalue::d</a>, <a class="el" href="ehrhart_8c_source.html#l00216">print_enode()</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00556">value_notone_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00464">value_print</a>.</p>

<p>Referenced by <a class="el" href="eval__ehrhart_8c_source.html#l00158">compute_poly()</a>, <a class="el" href="ehrhart_8c_source.html#l02281">Ehrhart_Quick_Apx_Full_Dim()</a>, <a class="el" href="ehrhart_8c_source.html#l01738">Enumerate_NoParameters()</a>, <a class="el" href="ehrhart__lower__bound_8c_source.html#l00025">main()</a>, <a class="el" href="ehrhart_8c_source.html#l01246">P_Enum()</a>, <a class="el" href="ehrhart_8c_source.html#l01860">Polyhedron_Enumerate()</a>, <a class="el" href="ehrhart_8c_source.html#l00216">print_enode()</a>, and <a class="el" href="testCompressParms_8c_source.html#l00273">test_Constraints_fullDimensionize()</a>.</p>

</div>
</div>
<a class="anchor" id="ae02ef07ca7d9de519ffe46a89e941bb8"></a><!-- doxytag: member="ehrhart.h::reduce_evalue" ref="ae02ef07ca7d9de519ffe46a89e941bb8" args="(evalue *e)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void reduce_evalue </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct__evalue.html">evalue</a> *&nbsp;</td>
          <td class="paramname"> <em>e</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>e</em>&nbsp;</td><td>pointer to an evalue </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="ehrhart_8c_source.html#l00295">295</a> of file <a class="el" href="ehrhart_8c_source.html">ehrhart.c</a>.</p>

<p>References <a class="el" href="types_8h_source.html#l00201">_enode::arr</a>, <a class="el" href="types_8h_source.html#l00190">_evalue::d</a>, <a class="el" href="ehrhart_8c_source.html#l00261">eequal()</a>, <a class="el" href="ehrhart_8c_source.html#l00139">free_evalue_refs()</a>, <a class="el" href="vector_8c_source.html#l00760">p</a>, <a class="el" href="types_8h_source.html#l00181">periodic</a>, <a class="el" href="types_8h_source.html#l00181">polynomial</a>, <a class="el" href="ehrhart_8c_source.html#l00295">reduce_evalue()</a>, <a class="el" href="types_8h_source.html#l00199">_enode::size</a>, <a class="el" href="types_8h_source.html#l00198">_enode::type</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00462">value_clear</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00554">value_notzero_p</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00555">value_one_p</a>, and <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00553">value_zero_p</a>.</p>

<p>Referenced by <a class="el" href="ehrhart_8c_source.html#l02281">Ehrhart_Quick_Apx_Full_Dim()</a>, <a class="el" href="ehrhart_8c_source.html#l01860">Polyhedron_Enumerate()</a>, and <a class="el" href="ehrhart_8c_source.html#l00295">reduce_evalue()</a>.</p>

</div>
</div>
</div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:26 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
